

// ----------------------------------------------------------------------------
//   browser / feature detection
// ----------------------------------------------------------------------------

// stolen from youngpup!

isIE = window.clientInformation ? true : false
isIEDTD = ((document.doctype && document.doctype.name.indexOf(".dtd")>-1) || document.compatMode == "CSS1Compat") ? true : false;
isN4 = document.layers ? true : false
isN6  = navigator.appName == "Netscape" && parseInt(navigator.appVersion) >= 5
isO5 = navigator.userAgent.indexOf("Opera") != -1 && parseInt(navigator.appVersion) >= 4

ie = document.all != null && !isO5;
safari = navigator.userAgent.indexOf("Safari/125") != -1;
moz = !ie && !safari && document.getElementById != null && document.layers == null && navigator.userAgent.indexOf("Netscape/7.02") == -1 && (navigator.userAgent.indexOf("Gecko") || navigator.userAgent.indexOf("Firefox"));
mac = (navigator.userAgent.indexOf("Macintosh") != -1 || navigator.userAgent.indexOf("Mac_PowerPC") != -1);

// ----------------------------------------------------------------------------
//   form submission / effects processing
// ----------------------------------------------------------------------------


function statusifyElements(root) {
  var as = root.getElementsByTagName("a");
  for (var i = 0; i < as.length; i++) {
    var anchor = as[i];
    if (anchor.title) {
      anchor.onmouseover = function() { window.status = this.title; return true; }
      anchor.onmouseout = function() { window.status = ''; return true; }
    }
  }
  var as = root.getElementsByTagName("img");
  for (var i = 0; i < as.length; i++) {
    var img = as[i];
    if (img.title) {
      img.onmouseover = function() { window.status = this.title; return true; }
      img.onmouseout = function() { window.status = ''; return true; }
    }
  }
}

function urlAttributeAdjust(url, name, val) {

  if (url.match(new RegExp("(\\?|\\&)" + name + "=([^&]*)", "g"))) {
    url= url.replace(new RegExp("(\\?|\\&)" + name + "=([^&]*)", "g"), "$1" + name + "=" + val);
  } else {
    if (url.indexOf("?") == -1) {
      url = url + "?" + name + "=" + val;
    } else {
      url = url + "&" + name + "=" + val;
    }
  }
  return( url );

}

function disableButtonForAction(buttonObj) {
  buttonObj.disabled = 'true';
//  buttonObj.value = 'Submitting..';
}

function smartSubmit(buttonObj, formName) {
  disableButtonForAction( buttonObj );
  document.forms[formName].submit();
  return true;
}

function smartLocation(buttonObj, loc) {
  disableButtonForAction( buttonObj );
  document.location = loc;
  return true;
}

function smartGoBack(buttonObj) {
  disableButtonForAction( buttonObj );
  history.go(-1);
  return true;
}

function smartCancel() {
  window.close();
}

function scrollToElement(name) {
  window.scrollTo(0, getYCoord(document.getElementById(name)) - 100 );
}

functionMap = new Array();
oldButtonColors = new Array();
numericChars = "0123456789";


function inputContainsErrors(targetId) {

  // method 1: fine errorText in it's standard title

  var titleObj = document.getElementById(targetId + '_title');
  if (titleObj) {
    var scanDivs = titleObj.getElementsByTagName("div");
    for (var i = 0; i < scanDivs.length; ++i) {
      if (scanDivs[i].className == "errorText") { return( true ); }
    }
  }
  return( false );

}

function autoFocus(formName, defaultFocus) {

  var f = document.forms[formName];
  if (!f) return;

  var elCount = f.elements.length;
  var errorsSeen = false;
  var focusEl = false;

  for (var i = 0; i < elCount; ++i) {
    el = f.elements[i];
    if (el.type == 'text' || el.type == 'edit' || el.type == 'password' || el.type == 'textarea' || el.type == 'checkbox' || el.type == 'radio' || el.type == 'select-one') {
      if (inputContainsErrors( el.id ) && !focusEl) {
        errorsSeen = true;
        focusEl = el;
      } else if (defaultFocus && !focusEl) {
        focusEl = el;
      }
    }
  }

  if (focusEl) focusEl.focus();

}

function initForm(formName) {
	if (document.forms[formName]) {
		var fName;
		var l = document.forms[formName].getElementsByTagName('label');
		for (var i = 0; i < l.length; i++) {
			fName = l[i].htmlFor;
			el = document.forms[formName][fName];
			if (el) {
				el.label = l[i];
				el.req=el.getAttribute('req');
				if (el.req == 1)
					el.label.insertAdjacentHTML('beforeBegin','<span class=required>*&nbsp;</span>');
	  			el.onfocus = function() {
	  				addClass(this.label, 'active');
					addClass(this, 'active');
	  			};
				el.onblur = function() {
	  				removeClass(this.label, 'active');
					removeClass(this, 'active');
	  			};
			}
		}
	}
	/*
	// load arrays
	radios = new Array();
	checks = new Array();
	// store vars
	var radio_store = '';
	// init all titles 
	// bs_ttt_initAll();
	// get form elements
	var f = document.forms[formName];
	if (!f) return;

	var elCount = f.elements.length;

	for (var i = 0; i < elCount; i++) {

    	el = f.elements[i];
    	if (el.type == 'text' || el.type == 'password' || el.type == 'textarea') {
			el.label = el.name + '_label';
			if (document.getElementById(el.label)) {
	  			el.onfocus = function() {
	  				addClass(document.getElementById(this.label), 'active');
	  			};
				el.onblur = function() {
	  				removeClass(document.getElementById(this.label), 'active');
	  			};
			}
		
    	} else if (el.type == 'button' || el.type == 'submit') {

       		el.onfocus = function() {
				oldButtonColors[this.name] = this.style.backgroundColor; this.style.backgroundColor = '#BBBBBB';
			};
       		el.onblur  = function() {
				this.style.backgroundColor = oldButtonColors[this.name];
			};
		
    	} else if (el.type == 'checkbox') {
			checks[checks.length]=el;
		} else if (el.type == 'radio' && radio_store != el.name) {
			radios[radios.length]=el;
			radio_store = el.name;
		} 
	}
	// load the checkbox skins
	for (var i = 0; i < checks.length; i++) {
		el = checks[i];
		bsCheck = new Bs_Checkbox();
		bsCheck.loadSkin('smoothstreak');
		bsCheck.imgStyle     = 'margin:2px; vertical-align:middle;';
		bsCheck.useMouseover = false;
		bsCheck.convertField(el.name);
	}
	// load the radio skins
	for (var i = 0; i < radios.length; i++) {
		el = radios[i];
		bsRadio = new Bs_Radio();
		bsRadio.loadSkin('smoothstreak');
		bsRadio.imgStyle     = 'margin:2px; vertical-align:middle;';
		bsRadio.convertField(el.name);
	}
	*/
}


// ----------------------------------------------------------------------------
//   add string helpers
// ----------------------------------------------------------------------------

Date.prototype.getFullYear =  function () { return( window.moz || window.safari ? this.getYear() + 1900 : this.getYear() ); }

String.prototype.trim =  function () { return this.replace(/^\s+/,'').replace(/\s+$/,''); }

function escapeForJS(str) {
  return( str.replace(/"\'"/g, "\\\'").replace(/"\""/g, "\\\"") );
}

function capitalizeFirst(s) {
  return( s.substring(0,1).toUpperCase() + s.substring(1).toLowerCase() );
}

String.prototype.endsWith = function(sEnd) {
  return (this.substr(this.length-sEnd.length)==sEnd);
}

String.prototype.startsWith = function(sStart) {
  return (this.substr(0,sStart.length)==sStart);
}

// ----------------------------------------------------------------------------
//   global functions
// ----------------------------------------------------------------------------

function noop() { }

function getMouseRelativeX() {
  return( parseInt(window.event.clientX) );
}
function getMouseRelativeY() {
  return( parseInt(window.event.clientY) );
}

function getMouseX(e)
{
  if (!e) var e = window.event;
  if (e.pageX) return e.pageX;
  return e.clientX + getViewportScrollX();
}
function getMouseY(e)
{
  if (!e) var e = window.event;
  if (e.pageY) return e.pageY;
  return e.clientY + getViewportScrollY();
}

function getWidth(obj) {
  return( parseInt(obj.offsetWidth) );
}
function getHeight(obj) {
  return( parseInt(obj.offsetHeight) );
}
function getLeft(obj) {
  return( parseInt(obj.offsetLeft) );
}
function getTop(obj) {
  return( parseInt(obj.offsetTop) );
}

function setLeft(obj, distance) {
  obj.style.left = distance + "px";
}

function setTop(obj, distance) {
  obj.style.top = distance + "px";
}

function getX(obj) {
  x = getLeft(obj);
  while (obj.offsetParent.tagName != "BODY" && obj.offsetParent.tagName != "HTML") {
    obj = obj.offsetParent;
    if (obj.offsetParent.tagName != "FORM") { x += getLeft(obj); }
  }
  return( x );
}
function getY(obj) {

  y = getTop(obj);
  while (obj.offsetParent.tagName != "BODY" && obj.offsetParent.tagName != "HTML") {
    obj = obj.offsetParent;
    if (obj.offsetParent.tagName != "FORM") { y += getTop(obj); }
  }
  return( y );
}

function isHidden(obj) {
  return( obj.style.display == "none" );
}

function isVisible(obj) {
  return( !isHidden(obj) );
}

function hideObject(obj) {
  if (obj) obj.style.display = "none";
}
function showObject(obj) {
  if (obj) obj.style.display = "";
}

function toggleVisibility(obj) {
  if (isHidden(obj)) {
    showObject(obj);
  } else {
    hideObject(obj);
  }
}

function trim(str) {
  var idx_start = 0;
  var idx_end = str.length - 1;
  while (str.charAt(idx_start) == ' ') { idx_start++; }
  while (str.charAt(idx_end) == ' ') { idx_end--; }
  return( str.substr(idx_start, (idx_end - idx_start + 1)) );
}

function trimNums(str) {
  var idx_start = 0;
  var idx_end = str.length - 1;
  while (str.charAt(idx_start) == ' ' || !isNaN(str.charAt(idx_start)) || str.charAt(idx_start) == '_') { idx_start++; }
  while (str.charAt(idx_end) == ' ' || !isNaN(str.charAt(idx_end)) || str.charAt(idx_end) == '_') { idx_end--; }
  return( str.substr(idx_start, (idx_end - idx_start + 1)) );
}

function getWindowHeight() {
  if (ie) {
    return( document.body.offsetHeight );
  } else {
    return( window.innerHeight );
  }
}

function getWindowWidth() {
  if (ie) {
    return( document.body.offsetWidth );
  } else {
    return( window.innerWidth );
  }
}

function expandWindowHeight(factor) {
  if (ie) {
    window.resizeBy( 0, factor );
  } else {
    window.innerHeight = window.innerHeight + factor;
  }
}

function expandWindowWidth(factor) {
  if (ie) {
    window.resizeBy( factor, 0 );
  } else {
    window.innerWidth = window.innerWidth + factor;
  }
}

function debug(x) {
  if( window.status.length > 0 )
    window.status = window.status + ' | ' + x;
  else
    window.status = x;
}


function getWindowScroll(w) {
  if (!w) {
    if (isIEDTD) return document.documentElement.scrollTop;
    else if (isIE) return document.body.scrollTop;
    else return window.pageYOffset
  } else {
    if (isIEDTD) return w.document.documentElement.scrollTop;
    else if (isIE) return w.document.body.scrollTop;
    else return w.pageYOffset
  }
}

function getIFrameDocument(fName) {
  if (window.safari) {
    return( window.frames[fName].document );
  } else {
    return( document.getElementById(fName).contentWindow.document );
  }

}

function addClass(element, className) {
	if (!hasClass(element, className)) {
		if (element.className) element.className += " " + className;
		else element.className = className;
	}
}

function removeClass(element, className) {
	var regexp = new RegExp("(^|\\s)" + className + "(\\s|$)");
	element.className = element.className.replace(regexp, "$2");
}

function hasClass(element, className) {
	var regexp = new RegExp("(^|\\s)" + className + "(\\s|$)");
	return regexp.test(element.className);
}

// ----------------------------------------------------------------------------
//   cookie functions
// ----------------------------------------------------------------------------

function setCookie(sName, sValue, expires, path, domain) {
  document.cookie = sName + "=" + escape(sValue) + (expires == null ? "" : "; expires=" + expires) + ((path == null)   ? "" : "; path=" + path) + ((domain == null)  ? "" : "; domain=" + domain);
}

function delCookie(sName, path, domain) {
  document.cookie = sName + "=" + escape(getCookie(sName)) + ";expires=" + new Date("December 31, 1975").toGMTString() + ((path == null) ? "" : "; path=" + path) + ((domain == null)  ? "" : "; domain=" + domain);
}

function getCookie(sCookie) {
  var aCookie = document.cookie.split(";");
  for (var i = 0; i < aCookie.length; i++)
  {
    var aCrumb = aCookie[i].split("=");
    if (sCookie == trim(unescape(aCrumb[0]))) {
      return( unescape(aCrumb[1]) );
    }
  }
  return( null );
}

function getCookieDomain(fullhost) {
  var hs = fullhost.split(".");
  if (hs.length - 2 < 0) {
    return( "" );
  } else {
    return( "." + hs[hs.length - 2] + "." + hs[hs.length - 1] );
  }
}

function toggleContentElement(srcCheckbox, tgtElement) {
  if ( srcCheckbox.checked ) {
    showObject(tgtElement);
  } else {
    hideObject(tgtElement);
  }
}

function toggleContentElementByValue(val, tgtElement) {
  if ( val ) {
    showObject(tgtElement);
  } else {
    hideObject(tgtElement);
  }
}

// ----------------------------------------------------------------------------
//   ie emulation (erik arvidson)
// ----------------------------------------------------------------------------

if (!safari && /Mozilla\/5\.0/.test(navigator.userAgent)) {

	var capture = ["click",	"mousedown", "mouseup",	"mousemove", "mouseover", "mouseout" ];

	HTMLElement.prototype.setCapture = function(){
		var self = this;
		var flag = false;
		this._capture = function(event){
			if (flag) {return}
			flag = true;
			self.dispatchEvent(event);
			flag = false;
		};
		for (var i=0; i<capture.length; i++) {
			window.addEventListener(capture[i], this._capture, true);
			window.captureEvents(Event[capture[i]]);
		}
	};

	HTMLElement.prototype.releaseCapture = function(){
		for (var i=0; i<capture.length; i++) {
			window.releaseEvents(Event[capture[i]]);
			window.removeEventListener(capture[i], this._capture, true);
		}
		this._capture = null;
	};
	
  HTMLElement.prototype.__defineGetter__("innerText", function(){
    return this.innerHTML.replace(/<[^>]+>/g,"");
  });

  HTMLElement.prototype.__defineSetter__("innerText", function(txtStr){
    var parsedText = document.createTextNode(txtStr);
    this.innerHTML = "";
    this.appendChild( parsedText );
  });
  
  HTMLElement.prototype.__defineGetter__("children", function () {
   var tmp = [];
   var j = 0;
   var n;
   for (var i = 0; i < this.childNodes.length; i++) {
      n = this.childNodes[i];
      if (n.nodeType == 1) {
         tmp[j++] = n;
         if (n.name) {  // named children
            if (!tmp[n.name])
               tmp[n.name] = [];
            tmp[n.name][tmp[n.name].length] = n;
         }
         if (n.id)      // child with id
            tmp[n.id] = n
      }
   }
   return tmp;
});

	Event.prototype.__defineGetter__("srcElement", function () {
		var node = this.target;
		while (node.nodeType != 1) node = node.parentNode;
		return node;
	});
  
	HTMLElement.prototype.attachEvent = function (sType, fHandler) {
		var shortTypeName = sType.replace(/on/, "");
		fHandler._ieEmuEventHandler = function (e) {
			window.event = e;
			return fHandler();
		};
		this.addEventListener(shortTypeName, fHandler._ieEmuEventHandler, false);
	};

  HTMLElement.prototype.insertAdjacentHTML = function (sWhere, sText) {

     var r = document.createRange();
     switch (sWhere) {
      case "beforeBegin":
       r.setStartBefore(this);
       this.parentNode.insertBefore(r.createContextualFragment(sText), this);
       break;

      case "afterBegin":
       r.setStartBefore(this.firstChild);
       this.insertBefore(r.createContextualFragment(sText), this.firstChild);
       break;

      case "beforeEnd":
       r.setStartAfter(this.lastChild);
       this.appendChild(r.createContextualFragment(sText));
       break;

      case "afterEnd":
       r.setStartAfter(this);
       this.parentNode.insertBefore(r.createContextualFragment(sText), this.nextSibling);

       break;
     }

  }


}


// ----------------------------------------------------------------------------
//   form radio button helpers
// ----------------------------------------------------------------------------

function setRadioValue(formname, radioname, val) {

  obj = document.forms[formname][radioname];
  for(i=0;i<obj.length;i++) {
    if (obj[i].value == val) obj[i].checked = true;
  }

}

function getRadioValue(formname, radioname) {

  obj = document.forms[formname][radioname];
  for(i=0;i<obj.length;i++) {
    if (obj[i].checked) return( obj[i].value );
  }

}

function getRadio(formname, radioname, val) {

  obj = document.forms[formname][radioname];

  for(i=0;i<obj.length;i++) {
    if (obj[i].value == val) return( obj[i] );
  }

}

function getSelectOptionTitleByValue(formname, fieldName, val) {

  obj = document.forms[formname][fieldName];
  for (var i = 0; i < obj.length; ++i) {
    if (obj[i].value == val) { return( obj[i].text ); }
  }
  return( null );

}

function setFieldValue(formname, fieldName, val) {

  obj = document.forms[formname][fieldName];

  if (obj.tagName.toLowerCase() == "select") {

    for (var i = 0; i < obj.length; ++i) {
      if (obj[i].value == val) { obj.selectedIndex = i; break; }
    }

  } else {

    obj.value = val;

  }

}

function setFieldDisabled(formname, fieldName) {

  obj = document.forms[formname][fieldName];
  obj.style.color = '#727272';
  obj.style.backgroundColor = '#F9F9F9';
  obj.readOnly = 1;

}

function setFieldEnabled(formname, fieldName) {

  obj = document.forms[formname][fieldName];
  obj.style.color = '#000000';
  obj.style.backgroundColor = '#FFFFFF';
  obj.readOnly = 0;

}

function addEvent(obj, et, f) {
  if (obj.addEventListener) {
    obj.addEventListener(et, f, false);
    return( true );
  } else if (obj.attachEvent) {
    var r = obj.attachEvent('on' + ret, f);
    return( r );
  }
  return( false );
}

function cleanForHTML(s) {

  s = s.replace(new RegExp("(|)", "g"), "\"");
  s = s.replace(new RegExp("(|)", "g"), "--");
  s = s.replace(new RegExp("(|)", "g"), "'");
  s = s.replace(new RegExp("", "g"), "...");
  s = s.replace(new RegExp("", "g"), "*");

  return( s );

}

// ----------------------------------------------------------------------------
//   other functions
// ----------------------------------------------------------------------------

function setPosition() {
	var topFrame = document.getElementById("head");
  	var midFrame = document.getElementById("main");
  	var botFrame = document.getElementById("foot");
	setPos = function() {
	midFrame.style.height = (getWindowHeight() - botFrame.offsetHeight - topFrame.offsetHeight) + 'px';
	}
	if (window.attachEvent)
		window.attachEvent('onresize', setPos);
	else if (window.addEventListener)
		window.addEventListener('resize', setPos, false);
	setPos();
}

function setGrid() {
	var main=document.getElementById("main");
	var gridBody=document.getElementById("gridBody");
	var gridCols=document.getElementById("gridCols");
	var gridRows=document.getElementById("gridRows");
	setGd = function() {
		gridBody.style.height=main.offsetHeight + 100 + 'px';
		var scrollbarwidth=gridBody.offsetWidth-gridBody.clientWidth;
		gridCols.style.marginRight=scrollbarwidth + 'px';
	}
	if (window.attachEvent)
		window.attachEvent('onresize', setGd);
 	else if (window.addEventListener)
		window.addEventListener('resize', setGd, false);
	setGd();
}

function loadPage (id,name) {
var html="<table cellpadding=0 class=headTable style='float:right'><tr><td><a href=page_props.html?id="+id+" target='mainFrame'>Page Properties</a> | <a href=page_edit.html?id="+id+" target='mainFrame'>Design Page</a> | <a>Preview</a> | <a>Publish</a> | </td><td><img src='/aura/icons/files2.gif'></td></tr></table>"+ name;
document.getElementById('mainHead').innerHTML=html;
mainFrame.location='page_edit.html?id=' + id;
}

function loadCampaign (id,name) {
var html="<table cellpadding=0 class=headTable style='float:right'><tr><td><img src='/aura/icons/email2.gif'></td></tr></table>"+ name;
document.getElementById('mainHead').innerHTML=html;
mainFrame.location='campaign_news.html?id=' + id;
}

function loadNewsletter (id,name) {
var html="<table cellpadding=0 class=headTable style='float:right'><tr><td><a href='javascript:parent.loadCampaign(3,\"My Campaign 1\");' target='mainFrame'>Campaign Settings</a> | <a href=news_props.html?id="+id+" target='mainFrame'>Newsletter Properties</a> |  <a href=page_edit.html?id="+id+" target='mainFrame'>Design Newsletter</a> |<a>Preview</a> |</td><td><img src='/aura/icons/files2.gif'></td></tr></table>"+ name;
document.getElementById('mainHead').innerHTML=html;
mainFrame.location='page_edit.html?id=' + id;
}

function editContent(id) {
window.open('/page_blurb_edit.html?id=' + id,'editContent' + id,'width=765,height=560,scrollbars=no,resizable=yes,titlebar=yes,menubar=no,toolbar=no');
    }
function addContent() {
window.open('/page_blurb_add.html','addContent','width=765,height=560,scrollbars=no,resizable=yes,titlebar=yes,menubar=no,toolbar=no');
    }
	
function initTabs(id) {
	this._selected=1;
	//var el=document.getElementById(id);
	//var tabs=el.getElementsByTagName('a');
	//for (var i = 0; i < tabs.length; ++i) {
	//	tabs[i].onclick=function() {setActiveTab()};
	//}
}
setActiveTab = function(num) {
	var activetab=document.getElementById('tab'+num+'anchor');
	var oldtab=document.getElementById('tab'+this._selected+'anchor');
	var activecontent=document.getElementById('tab'+num+'content');
	var oldcontent=document.getElementById('tab'+this._selected+'content');
	
	activetab.className='active';
	oldtab.className='';
	hideObject(oldcontent);
	showObject(activecontent);
	
	this._selected=num;
}

function initMain() {
		var grip = document.getElementById("grip");
		var split = document.getElementById("split");
		var ghost = document.getElementById("ghost");
		var shield = document.getElementById("shield");
		var mainHead = document.getElementById("mainHead");
		var mainFrame = document.getElementById("mainFrame");
		var mainPane = document.getElementById("mainPane");
		var navPane = document.getElementById("navPane");
		
		var l = 180;
		if (grip._position != null)
			l=grip._position;
		// set height
		function setPaneHeight() {
			mainFrame.style.height=getWindowHeight() - mainHead.offsetHeight + 'px';
		}
		// set widths
		function setPaneWidth(l) {
			navPane.style.width = l + 'px';
			grip.style.left = l + 'px';
			split.style.left = l + 'px';
			ghost.style.left = l + 1 + 'px';
			navPane.style.width = l + 'px';
			mainPane.style.marginLeft = l + 7 + 'px';
			
			if (l) {
				grip.className='grip-left';
				grip._expanded=1;
				grip._position=l;
			}
			else {
				grip.className='grip-right';
				grip._expanded=0;
			}
		}
		// set up grip
		grip.onclick= function() {
			if (grip._expanded) {
				setPaneWidth(0);
			}
			else {
				setPaneWidth(grip._position);
			}
			this.blur();
		}
		//set up drag
		Drag.init(ghost,null, 100, 400, 0, 0);
		ghost.onDragStart= function() {
			if (ie)
				ghost.setCapture();
			else
				shield.style.display='block';
			ghost.className='ghost-drag';
		}
		ghost.onDragEnd= function(l) {
			if (ie)
				ghost.releaseCapture();
			else
				shield.style.display='none';
			ghost.className='';
			setPaneWidth(l);
		}
		// finish up sizing
		setPaneWidth(l);
		// render the navBar
		navBar1 = new navBar('navBar1', storage_navBar1);
		navBar1.render('navPane');
		setPaneHeight();
		if (window.attachEvent)
			window.attachEvent('onresize', setPaneHeight);
		else
			window.addEventListener('resize', setPaneHeight, false);
	}
	
	
	

